Skip to main content
Version: 10.1

Device Resource

Description​

This resource is for managing a single device. 

GET /devices/:ID​

Get information on the selected device.

GET Parameters​

NameRequiredTypeDescriptionDefault Value
:IDYesURL ParameterThe unique ID of the device. 

GET Response Values​

NameTypeDescription
device_classJSON StringThe class of the device. Currently this will always be "cpe".
addressJSON StringThe address of the device. Normally this will either be the IP address or the hostname used for the device.
host_hex_fingerprintJSON StringThe host hex fingerprint. Typically this is set to "ignore".
nameJSON StringThe display name of the device in rWeb.
usernameJSON StringThe username used for connecting to the device. Default is "admin".
connection_statusJSON StringThe current status of rWeb's connection to the device. This is "connected" when the device is reachable, and becomes "no route to host" when the device is unreachable. When a device is unreachable, many other device values listed here will revert to "false", since its current status is not known. Any scripts relying on knowing device functionality should only trust responses while the device is in the "connected" state.
supports_tcp_dumpJSON BooleanWhether the device supports tcpdump.
jumbo_frame_support_levelJSON StringThis will be "rw" if jumbo frames can be enabled, "ro" if the device has the capability but it isn't supported, and "none" if there is no jumbo frame functionality.
device_resourceJSON StringThe unique device resource for this device.
device_status_resourceJSON StringThe device status resource for this device.
device_configurations_resourceJSON StringThe device configurations resource for this device.
device_local_configurations_resourceJSON StringThe device local configurations resource for this device.
device_values_resourceJSON StringThe device values resource for this device.
command_resourceJSON StringThe command resource for this device.
load_resourceJSON StringThe load resource for this device.
upgrade_resourceJSON StringThe upgrade resource for this device.
change_password_resourceJSON StringThe change password resource for this device.
reboot_resourceJSON StringThe reboot resource for this device.
log_resourceJSON StringThe log resource for this device.
device_zones_resourceJSON StringThe device zones resource for this device.
device_port_traffic_resourceJSON StringThe device port traffic resource for this device.
supports_ddos_commandJSON BooleanWhether the device supports internal DDoS commands. Primarily used for updated filter list functionality.
usage_resourceJSON StringThe usage resource for this device.
passwordJSON StringThe password rWeb will use when attempting to connect to the device.
tcp_dumps_resourceJSON StringThe tcp dumps resource for this device.
switchover_resourceJSON StringThe switchover resource for this device.
patch_panel_resourceJSON StringThe patch panel resource for this device.
tunnels_supportedJSON BooleanWhether this device supports tunnels.
tunnels_resourceJSON StringThe tunnels resource for this device.
snmp_supportedJSON StringWhether this device supports SNMP.
snmp_v1v2_resourceJSON StringThe resource for configuring SNMP v1 and v2 for this device.
snmp_v3_usm_resourceJSON StringThe resource for configuring SNMP v3 for this device.
license_supportedJSON BooleanWhether this device supports licensing. Functionally this will always be "true" and could only be "false" for extremely old versions of RIOS.
license_resourceJSON StringThe license resource for this device.
support_upload_supportedJSON BooleanWhether this device can generate support uploads.
support_upload_resourceJSON StringThe support upload resource for this device.
request_support_resourceJSON StringThe request support upload resource for this device.
support_dump_by_zoneidJSON BooleanWhether the device supports tcpdump across an entire zone. If "false", the device will require destination addresses to be specified for captures.
supports_filter_mode_offJSON BooleanWhether the device can set filter mode for algorithms to "off". Functionally this will always be "true" and could only be "false" for extremely old versions of RIOS.

Example GET Request​

 GET /devices/515

Example GET Response​

{
"device_class": "cpe",
"address": "rs30-3",
"host_hex_fingerprint": "ignore",
"name": "rs30-3",
"username": "admin",
"connection_status": "connected",
"supports_tcp_dump": true,
"jumbo_frame_support_level": "rw",
"device_resource": "/devices/515",
"device_status_resource": "/devices/515/status",
"device_configurations_resource": "/devices/515/configurations",
"device_local_configurations_resource": "/devices/515/local_configurations",
"device_values_resource": "/devices/515/values",
"command_resource": "/devices/515/current_command",
"load_resource": "/devices/515/load",
"upgrade_resource": "/devices/515/upgrade",
"downgrade_resource": "/devices/515/downgrade",
"change_password_resource": "/devices/515/change_password",
"reboot_resource": "/devices/515/reboot",
"log_resource": "/devices/515/logs",
"device_zones_resource": "/devices/515/zones",
"device_port_traffic_resource": "/devices/515/port_traffic",
"supports_ddos_command": true,
"usage_resource": "/devices/515/resource_usage",
"tcp_dumps_resource": "/devices/515/tcp_dump",
"switchover_resource": "/devices/515/switchover",
"tunnels_supported": true,
"tunnels_resource": "/devices/515/tunnels",
"snmp_supported": true,
"snmp_v1v2_resource": "/devices/515/snmp_v1v2",
"snmp_v3_usm_resource": "/devices/515/snmp_v3_usm",
"license_supported": true,
"license_resource": "/devices/515/licenses",
"support_upload_supported": true,
"support_upload_resource": "/devices/515/support_upload",
"request_support_resource": "/devices/515/request_support",
"support_dump_by_zoneid": true,
"supports_filter_mode_off": true
} 

PUT /devices/:ID​

Update a single device.

PUT Parameters​

NameRequiredTypeDescriptionDefault Value
:IDYesURL ParameterThe unique ID of the device to up 
addressNoJSON StringThe IP address or hostname for the new device. 
nameNoJSON StringThe display name for the device in rWeb. 
device_classNoJSON StringThis should be "CPE". 
usernameNoJSON StringThis should be "admin". 
passwordNoJSON StringThis will be the connection password. It may change depending on how you did the device installation, and whether or not you changed the password previously. 
host_hex_fingerprintNoJSON StringThis should be "ignore". 

Example PUT Request​

PUT /devices/515
 
JSON Body:
{
"data": {
"address":"rs30-3",
"name":"rs30-3",
"device_class":"CPE",
"username":"admin",
"password":"admin123",
"host_hex_fingerprint":"ignore"
}
}

Example PUT Response​

 HTTP/1.1 200 OK

DELETE /devices/:ID​

This will remove the device from rWeb.

DELETE Parameters​

NameRequiredTypeDescriptionDefault Value
:IDYesURL ParameterThe unique ID of the device to remove. 

Example DELETE Request​

 DELETE /devices/515

Example DELETE Response​

 HTTP/1.1 200 OK